#ifndef BENONDELETTES
#define BENONDELETTES

/*  benondelettes.h
     partir de : http://www.epm6604b.be/biblio/biblio.html
                  http://www.epm6604b.be/biblio/detail_ondelette.html
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>

/* dclaration des fonctions */

/* ondelette de Haar */

int haar(double *valeur, int m); /* transforme de Haar d'un tableau de 2^m valeurs */
int haar_inv(double *valeur, int m); /* transforme inverse de Haar d'un tableau de 2^m valeurs */
int haarn(double *valeur, int m); /* transforme de Haar normalis d'un tableau de 2^m valeurs */
int haarn_inv(double *valeur, int m); /* transforme inverse de Haar normalise d'un tableau de 2^m valeurs */

/* ondelettes Daubechies */

int daub4(double *valeur, int m); /* transforme de Daubechies 4 d'un tableau de 2^m valeurs */
int daub4_inv(double *valeur, int m); /* transforme inverse de Daubechies 4 d'un tableau de 2^m valeurs */
int daub6(double *valeur, int m); /* transforme de Daubechies 6 d'un tableau de 2^m valeurs */
int daub6_inv(double *valeur, int m); /* transforme inverse de Daubechies 6 d'un tableau de 2^m valeurs */
int daub8(double *valeur, int m); /* transforme de Daubechies 8 d'un tableau de 2^m valeurs */
int daub8_inv(double *valeur, int m); /* transforme inverse de Daubechies 8 d'un tableau de 2^m valeurs */
int daub10(double *valeur, int m); /* transforme de Daubechies 10 d'un tableau de 2^m valeurs */
int daub10_inv(double *valeur, int m); /* transforme inverse de Daubechies 10 d'un tableau de 2^m valeurs */
int daub12(double *valeur, int m); /* transforme de Daubechies 12 d'un tableau de 2^m valeurs */
int daub12_inv(double *valeur, int m); /* transforme inverse de Daubechies 12 d'un tableau de 2^m valeurs */
int daub14(double *valeur, int m); /* transforme de Daubechies 14 d'un tableau de 2^m valeurs */
int daub14_inv(double *valeur, int m); /* transforme inverse de Daubechies 14 d'un tableau de 2^m valeurs */
int daub16(double *valeur, int m); /* transforme de Daubechies 16 d'un tableau de 2^m valeurs */
int daub16_inv(double *valeur, int m); /* transforme inverse de Daubechies 16 d'un tableau de 2^m valeurs */
int daub18(double *valeur, int m); /* transforme de Daubechies 18 d'un tableau de 2^m valeurs */
int daub18_inv(double *valeur, int m); /* transforme inverse de Daubechies 18 d'un tableau de 2^m valeurs */
int daub20(double *valeur, int m); /* transforme de Daubechies 20 d'un tableau de 2^m valeurs */
int daub20_inv(double *valeur, int m); /* transforme inverse de Daubechies 20 d'un tableau de 2^m valeurs */
int daub22(double *valeur, int m); /* transforme de Daubechies 22 d'un tableau de 2^m valeurs */
int daub22_inv(double *valeur, int m); /* transforme inverse de Daubechies 22 d'un tableau de 2^m valeurs */
int daub24(double *valeur, int m); /* transforme de Daubechies 24 d'un tableau de 2^m valeurs */
int daub24_inv(double *valeur, int m); /* transforme inverse de Daubechies 24 d'un tableau de 2^m valeurs */
int daub32(double *valeur, int m); /* transforme de Daubechies 32 d'un tableau de 2^m valeurs */
int daub32_inv(double *valeur, int m); /* transforme inverse de Daubechies 32 d'un tableau de 2^m valeurs */

/* ondelettes Symmlet */

int symmlet6(double *valeur, int m); /* transforme de Symmlet 6 d'un tableau de 2^m valeurs */
int symmlet6_inv(double *valeur, int m); /* transforme inverse de Symmlet 6 d'un tableau de 2^m valeurs */
int symmlet8(double *valeur, int m); /* transforme de Symmlet 8 d'un tableau de 2^m valeurs */
int symmlet8_inv(double *valeur, int m); /* transforme inverse de Symmlet 8 d'un tableau de 2^m valeurs */
int symmlet10(double *valeur, int m); /* transforme de Symmlet 10 d'un tableau de 2^m valeurs */
int symmlet10_inv(double *valeur, int m); /* transforme inverse de Symmlet 10 d'un tableau de 2^m valeurs */
int symmlet12(double *valeur, int m); /* transforme de Symmlet 12 d'un tableau de 2^m valeurs */
int symmlet12_inv(double *valeur, int m); /* transforme inverse de Symmlet 12 d'un tableau de 2^m valeurs */
int symmlet14(double *valeur, int m); /* transforme de Symmlet 14 d'un tableau de 2^m valeurs */
int symmlet14_inv(double *valeur, int m); /* transforme inverse de Symmlet 14 d'un tableau de 2^m valeurs */
int symmlet16(double *valeur, int m); /* transforme de Symmlet 16 d'un tableau de 2^m valeurs */
int symmlet16_inv(double *valeur, int m); /* transforme inverse de Symmlet 16 d'un tableau de 2^m valeurs */
int symmlet18(double *valeur, int m); /* transforme de Symmlet 18 d'un tableau de 2^m valeurs */
int symmlet18_inv(double *valeur, int m); /* transforme inverse de Symmlet 18 d'un tableau de 2^m valeurs */
int symmlet20(double *valeur, int m); /* transforme de Symmlet 20 d'un tableau de 2^m valeurs */
int symmlet20_inv(double *valeur, int m); /* transforme inverse de Symmlet 20 d'un tableau de 2^m valeurs */
int symmlet22(double *valeur, int m); /* transforme de Symmlet 22 d'un tableau de 2^m valeurs */
int symmlet22_inv(double *valeur, int m); /* transforme inverse de Symmlet 22 d'un tableau de 2^m valeurs */
int symmlet24(double *valeur, int m); /* transforme de Symmlet 24 d'un tableau de 2^m valeurs */
int symmlet24_inv(double *valeur, int m); /* transforme inverse de Symmlet 24 d'un tableau de 2^m valeurs */

/* ondelettes Coiflet */

int coiflet6(double *valeur, int m); /* transforme de Coiflet 6 d'un tableau de 2^m valeurs */
int coiflet6_inv(double *valeur, int m); /* transforme inverse de Coiflet 6 d'un tableau de 2^m valeurs */
int coiflet12(double *valeur, int m); /* transforme de Coiflet 12 d'un tableau de 2^m valeurs */
int coiflet12_inv(double *valeur, int m); /* transforme inverse de Coiflet 12 d'un tableau de 2^m valeurs */
int coiflet18(double *valeur, int m); /* transforme de Coiflet 18 d'un tableau de 2^m valeurs */
int coiflet18_inv(double *valeur, int m); /* transforme inverse de Coiflet 18 d'un tableau de 2^m valeurs */
int coiflet24(double *valeur, int m); /* transforme de Coiflet 24 d'un tableau de 2^m valeurs */
int coiflet24_inv(double *valeur, int m); /* transforme inverse de Coiflet 24 d'un tableau de 2^m valeurs */
int coiflet30(double *valeur, int m); /* transforme de Coiflet 30 d'un tableau de 2^m valeurs */
int coiflet30_inv(double *valeur, int m); /* transforme inverse de Coiflet 30 d'un tableau de 2^m valeurs */
int coiflet36(double *valeur, int m); /* transforme de Coiflet 36 d'un tableau de 2^m valeurs */
int coiflet36_inv(double *valeur, int m); /* transforme inverse de Coiflet 36 d'un tableau de 2^m valeurs */
int coiflet42(double *valeur, int m); /* transforme de Coiflet 42 d'un tableau de 2^m valeurs */
int coiflet42_inv(double *valeur, int m); /* transforme inverse de Coiflet 42 d'un tableau de 2^m valeurs */
int coiflet48(double *valeur, int m); /* transforme de Coiflet 48 d'un tableau de 2^m valeurs */
int coiflet48_inv(double *valeur, int m); /* transforme inverse de Coiflet 48 d'un tableau de 2^m valeurs */
int coiflet54(double *valeur, int m); /* transforme de Coiflet 54 d'un tableau de 2^m valeurs */
int coiflet54_inv(double *valeur, int m); /* transforme inverse de Coiflet 54 d'un tableau de 2^m valeurs */
int coiflet60(double *valeur, int m); /* transforme de Coiflet 60 d'un tableau de 2^m valeurs */
int coiflet60_inv(double *valeur, int m); /* transforme inverse de Coiflet 60 d'un tableau de 2^m valeurs */


/* ondelettes biorthogonales */

int bio13(double *valeur, int m); /* transforme biorthogonale 1.3 tableau de 2^m valeurs */
int bio13_inv(double *valeur, int m); /* transforme biorthogonale 1.3 inverse d'un tableau de 2^m valeurs */
int bio15(double *valeur, int m); /* transforme biorthogonale 1.5 tableau de 2^m valeurs */
int bio15_inv(double *valeur, int m); /* transforme biorthogonale 1.5 inverse d'un tableau de 2^m valeurs */
int bio22(double *valeur, int m); /* transforme biorthogonale 2.2 tableau de 2^m valeurs */
int bio22_inv(double *valeur, int m); /* transforme biorthogonale 2.2 inverse d'un tableau de 2^m valeurs */
int bio24(double *valeur, int m); /* transforme biorthogonale 2.4 tableau de 2^m valeurs */
int bio24_inv(double *valeur, int m); /* transforme biorthogonale 2.4 inverse d'un tableau de 2^m valeurs */
int bio26(double *valeur, int m); /* transforme biorthogonale 2.6 tableau de 2^m valeurs */
int bio26_inv(double *valeur, int m); /* transforme biorthogonale 2.6 inverse d'un tableau de 2^m valeurs */
int bio28(double *valeur, int m); /* transforme biorthogonale 2.8 tableau de 2^m valeurs */
int bio28_inv(double *valeur, int m); /* transforme biorthogonale 2.8 inverse d'un tableau de 2^m valeurs */
int bio31(double *valeur, int m); /* transforme biorthogonale 3.1 tableau de 2^m valeurs */
int bio31_inv(double *valeur, int m); /* transforme biorthogonale 3.1 inverse d'un tableau de 2^m valeurs */
int bio33(double *valeur, int m); /* transforme biorthogonale 3.3 tableau de 2^m valeurs */
int bio33_inv(double *valeur, int m); /* transforme biorthogonale 3.3 inverse d'un tableau de 2^m valeurs */
int bio35(double *valeur, int m); /* transforme biorthogonale 3.5 tableau de 2^m valeurs */
int bio35_inv(double *valeur, int m); /* transforme biorthogonale 3.5 inverse d'un tableau de 2^m valeurs */
int bio37(double *valeur, int m); /* transforme biorthogonale 3.7 tableau de 2^m valeurs */
int bio37_inv(double *valeur, int m); /* transforme biorthogonale 3.7 inverse d'un tableau de 2^m valeurs */
int bio39(double *valeur, int m); /* transforme biorthogonale 3.9 tableau de 2^m valeurs */
int bio39_inv(double *valeur, int m); /* transforme biorthogonale 3.9 inverse d'un tableau de 2^m valeurs */
int bio44(double *valeur, int m); /* transforme biorthogonale 4.4 tableau de 2^m valeurs */
int bio44_inv(double *valeur, int m); /* transforme biorthogonale 4.4 inverse d'un tableau de 2^m valeurs */
int bio55(double *valeur, int m); /* transforme biorthogonale 5.5 tableau de 2^m valeurs */
int bio55_inv(double *valeur, int m); /* transforme biorthogonale 5.5 inverse d'un tableau de 2^m valeurs */
int bio68(double *valeur, int m); /* transforme biorthogonale 6.8 tableau de 2^m valeurs */
int bio68_inv(double *valeur, int m); /* transforme biorthogonale 6.8 inverse d'un tableau de 2^m valeurs */

#endif  // BENONDELETTES
