#ifndef IMAGES
#define IMAGES

#include <windows.h>
#include <stdio.h>
#include <olectl.h>
extern "C" 
{ 
#include "png\png.h"  
#include "tiff\tiffio.h"  
} 
#include <GL/gl.h>

/* OpenGL texture info */
typedef struct
{
  GLsizei width;
  GLsizei height;
  GLenum format;
  GLint internalFormat;
  GLuint id;
  GLubyte *texels;
} gl_texture_t;

#pragma pack(push, 1)
/* tga header */
typedef struct
{
  GLubyte id_lenght;          
  GLubyte colormap_type;     
  GLubyte image_type;        
  short	cm_first_entry;  
  short	cm_length;       
  GLubyte   cm_size;       
  short	x_origin;     
  short	y_origin;   
  short	width;   
  short	height;  
  GLubyte pixel_depth;    
  GLubyte image_descriptor; 
} tga_header_t;
#pragma pack(pop)

extern void rer(int n);

void readGIF(char *szFileName, UCHAR **ucpBits, int *iWidth, int *iHeight);
void readPNG(char *szFileName, UCHAR **ucpBits, int *iWidth, int *iHeight);
void readPPM(char *szFileName, UCHAR **ucpBits, int *iWidth, int *iHeight);
void readTGA(char *szFileName, UCHAR **ucpBits, int *iWidth, int *iHeight);
void readTIFF(char *szFileName, UCHAR **ucpBits, int *iWidth, int *iHeight);

#endif  // IMAGES
