// MesImages : un afficheur de fichiers d'images
// Copyright  pgl10@yahoo.com 

#include "main.h"

#define DB_OK 1

#ifndef BKCHECK
#define BKCHECK
extern "C" void __pfnBkCheck() {}
#endif
    
// variables communes :

char monprojet[] = "MesImages v 0.8";
char nomModel[400]; // nom complet du fichier  afficher
int larg;           // largeur de l'image
int haut;           // hauteur de l'image
int lsup=10;        // supplment de largeur entre la fentre et l'image ( 2 marges )
int hsup=74;        // supplment exprimental de hauteur entre la fentre et l'image
int hbet;           // hauteur de barre d'tat
UCHAR *ucpBitsMem;  // les pixels BGRA de l'image
int cx,cy,xe,ye;    // largeur et hauteur de la fentre et de l'cran
int prem;           // prem : 1 pour le premier affichage et 0 ensuite
int zoom;           // zoom : 1 ( ch. 1 ) ou 2 ( ch. 1/2 ) ou 4 ( ch. 1/4 )
int imin;           // imin : 1 si l'image actuelle est une miniature ou 0 si non
int nmax;           // nombre d'images qui se suivent en fentre maximise
int faire;          // variable d'tat pour newModel : -1, 0, 1 ou 2 
char buf[1024];     // un buffer de travail rutilisable
int nn=4;           // nombre de niveaux pour la transforme en ondelettes 
int ms=3;           // mthode de seuillage dur ou doux ( dur : 1 ou 2 doux : 3 )
int intscr;         // entier lu par scrolling pour le seuil manuel de dbruitage
                    // si intscr=0 c'est le seuil automatique qui sera activ.

HINSTANCE hinst;
HWND hWnd,hEdit,hBe;
HDC hDC,hdcMem;
HBITMAP hBmpMem;

int inline mini(int i, int j){return (j>i)?i:j;}

int lmax() {   // largeur maximale de la fentre avec conservation du w/h
     return mini(lsup+xe-125,lsup+(int)((double)(ye-125)*(double)larg/(double)haut));
}

int hmax() {   // hauteur maximale de la fentre avec conservation du w/h
     return mini(hsup+ye-125,hsup+(int)((double)(xe-125)*(double)haut/(double)larg));
}

void informer(char *message) {   // pour un message simple dans une fentre
     MessageBox(hWnd, message, monprojet, MB_OK);
     return;  
}

void model() {                // pour la barre de titre.
char *buffer, *pointeur;
char name[80];
     strcpy(buf,nomModel);
     buffer = buf;
     while((pointeur=strchr(buffer,'\\')) != NULL) strcpy(buffer,pointeur+1);
     strcpy(name,buffer);
     strcpy(buf, monprojet);
     SetWindowText(hWnd,buf);      
     return;
}

void guider(char *message) {   // pour afficher le guidage dans la barre d'tat
     SendMessage(hBe, SB_SETTEXT, 0, (LONG)message);
     return;
}

void guidage() {                       // pour afficher les 
char nc[8],nm[300];                    // informations de l'image 
char *buffer, *pointeur;               // dans la barre d'tat 
     strcpy(buf," zoom 1");
     if(imin == 0) {
          if(zoom == 2) strcat(buf,"/2");  // les images miniatures sont
          if(zoom == 4) strcat(buf,"/4");  // affiches uniquement en chelle 1
     }
     strcat(buf," | ");
     strcpy(nm,nomModel);
     buffer = nm;
     while((pointeur=strchr(buffer,'\\')) != NULL) strcpy(buffer,pointeur+1); 
     if(prem == 0) strcat(buf,buffer);    
     if(prem == 1) strcat(buf,"[]"); 
     strcat(buf," : ");
     sprintf(nc,"%i",larg);
     strcat(buf,nc);
     strcat(buf," x ");
     sprintf(nc,"%i",haut),
     strcat(buf,nc);
     strcat(buf," pixels");
     guider(buf);
     return;
}

void modedemploi() {   // pour afficher le mode d'emploi
     strcpy(buf,"Pour ouvrir une image :\n- Fichier => Ouvrir\n- <ctrl>O\n- N ( nouveau )\n- <haut> : l'image ");
     strcat(buf,"prcdente\n- <bas> : l'image suivante\n- glisser-dposer le nom du fichier : \n   . sur le nom ");
     strcat(buf,"de l'excutable\n   . ou dans la fentre\n\nPour archiver l'image affiche :\n- Fichier => Archiver\n");
     strcat(buf,"\nPour fermer l'application :\n- Fichier => Quitter\n- <alt>F4\n- <chap>\n- Q ( quitter )\n");
     strcat(buf,"\nPour zoomer  1 ou 1/2 ou 1/4 :\n- Vue => Zoom\n- Z ( zoom )\n");
     strcat(buf,"\nPour afficher l'image avec du flou :\n- Vue => Flou\n- F ( flou )\n");
     strcat(buf,"\nPour choisir un seuil manuel de dbruitage :\n- Vue => Seuil manuel\n- S ( seuil )\n");
     strcat(buf,"S'il est nul le seuillage automatique est activ\n");
     strcat(buf,"\nPour changer la mthode de seuillage :\n- Vue => Seuillage dur ou doux\n- M ( mthode )\n");
     strcat(buf,"Au dbut le seuillage doux est activ par dfaut\n");
     strcat(buf,"\nPour dbruiter l'image affiche :\n- Vue => Dbruiter\n- D ( dbruiter )\n");
     strcat(buf,"\nPour voir le mode d'emploi :\n- Aide => Mode d'emploi\n- F1 ( aide )\n\n");
     MessageBox(hWnd, buf, monprojet, MB_ICONINFORMATION);
     return;
}

void nextImage() {  // on va chercher le fichier image suivant dans le mme dossier
HANDLE hFind; 
WIN32_FIND_DATA FindData; 
char *buffer, *pointeur;     
char dossier[300], name[80], type[5];
int i,n;
     strcpy(dossier,nomModel);
     for(i=0 ; i<(int)strlen(dossier); i++) if(dossier[i] == '\\') n = i;
     dossier[n+1] = '\0';      // le dossier du fichier image actuel
     strcpy(buf,nomModel);
     buffer = buf;
     while((pointeur=strchr(buffer,'\\')) != NULL) strcpy(buffer,pointeur+1); 
     strcpy(name,buffer);     // le nom du fichier image actuel
     while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1); 
     strcpy(type,buffer);     // le type du fichier image actuel
     SetCurrentDirectory(dossier); 
     hFind=FindFirstFile("*.*", &FindData);   // le 1-er fichier est toujours : ./
     while (FindNextFile(hFind, &FindData)) { 
          if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) 
               if(strncmp((const char *)FindData.cFileName,name,strlen(name)) == 0) break; 
     }   // on a retrouv le fichier de l'image actuelle dans son dossier
     if (hFind != INVALID_HANDLE_VALUE) {     // on continue  la suite
          while (FindNextFile(hFind, &FindData)) { 
               if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
                    strcpy(buf,(const char *)FindData.cFileName);
                    buffer = buf;
                    strcpy(type, "none");
                    if(strchr(buffer, '.') != NULL) {
                         while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1); 
                         strcpy(type,buffer);     // le type du nouveau fichier
                    }
                    if(isGood(type)) {
                         strcpy(nomModel,dossier);
                         strcat(nomModel,(const char *)FindData.cFileName);
                         return;             // on a trouv un bon fichier suivant
                    }
               }
          }
     } 
     hFind=FindFirstFile("*.*", &FindData);   
     if (hFind != INVALID_HANDLE_VALUE) {     // on recommence au dbut du dossier
          while (FindNextFile(hFind, &FindData)) { 
               if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
                    strcpy(buf,(const char *)FindData.cFileName);
                    buffer = buf;
                    strcpy(type, "none");
                    if(strchr(buffer, '.') != NULL) {
                         while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1); 
                         strcpy(type,buffer);     // le type du nouveau fichier
                    }
                    if(isGood(type)) {
                         strcpy(nomModel,dossier);
                         strcat(nomModel,(const char *)FindData.cFileName);
                         return;             // on a trouv un bon fichier suivant
                    }
               }
          }
     } 
     FindClose (hFind); 
     return;
}

void previousImage() {  // on va chercher le fichier image prcdent dans le mme dossier
HANDLE hFind; 
WIN32_FIND_DATA FindData; 
char *buffer, *pointeur;     
char dossier[300], name[80], type[5];
int i,n;
     strcpy(dossier,nomModel);
     for(i=0 ; i<(int)strlen(dossier); i++) if(dossier[i] == '\\') n = i;
     dossier[n+1] = '\0';      // le dossier du fichier image actuel
     strcpy(buf,nomModel);
     buffer = buf;
     while((pointeur=strchr(buffer,'\\')) != NULL) strcpy(buffer,pointeur+1); 
     strcpy(name,buffer);     // le nom du fichier image actuel
     while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1); 
     strcpy(type,buffer);     // le type du fichier image actuel
     SetCurrentDirectory(dossier); 
     strcpy(nomModel,"");
     hFind=FindFirstFile("*.*", &FindData);   // le 1-er fichier est toujours : ./
     while (FindNextFile(hFind, &FindData)) { 
          if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
               if(strncmp((const char *)FindData.cFileName,name,strlen(name)) == 0) break;  // si l'actuel
               strcpy(buf,(const char *)FindData.cFileName);                                // si non
               buffer = buf;
               strcpy(type, "none");
               if(strchr(buffer, '.') != NULL) {
                    while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1); 
                    strcpy(type,buffer);     // le type de ce fichier
               }
               if(isGood(type)) {
                    strcpy(nomModel,dossier);
                    strcat(nomModel,(const char *)FindData.cFileName);
               }
          }
     }
     if(strlen(nomModel) > 0) {        // on a dj trouv le fichier image pcdent
          FindClose (hFind); 
          return;
     }
     hFind=FindFirstFile("*.*", &FindData);   // si non, on recommence
     while (FindNextFile(hFind, &FindData)) { 
          if (!(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
               strcpy(buf,(const char *)FindData.cFileName);
               buffer = buf;
               strcpy(type, "none");
               if(strchr(buffer, '.') != NULL) {
                    while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1); 
                    strcpy(type,buffer);     // le type de ce fichier
               }
               if(isGood(type)) {       // le fichier actuel tait le premier fichier reconnu
                    strcpy(nomModel,dossier);              // donc, le fichier prcdent
                    strcat(nomModel,(const char *)FindData.cFileName);   // est le dernier reconnu
               }
          }
     }
     FindClose (hFind); 
     return;
}

char *filtre() {  // le filtre pour l'ouverture de nouveaux fichiers
int i,j,k;
char *f[7], *t[7];
     char tf[] = "Tous formats reconnus";
     f[0] = "Fichier *.bmp (*.bmp)";
     t[0] = "*.bmp;*.BMP";
     f[1] = "Fichier *.gif (*.gif)";
     t[1] = "*.gif;*.GIF";
     f[2] = "Fichier *.jpg (*.jpg)";
     t[2] = "*.jpg;*.JPG;*.jpeg;*.JPEG";
     f[3] = "Fichier *.png (*.png)";
     t[3] = "*.png;*.PNG";
     f[4] = "Fichier *.ppm (*.ppm)";
     t[4] = "*.ppm;*PPM";
     f[5] = "Fichier *.tga (*.tga)";
     t[5] = "*.tga;*TGA";
     f[6] = "Fichier *.tiff (*.tiff)";
     t[6] = "*.tif;*.TIF;*.tiff;*.TIFF";
     k = 0;
     strcpy(buf,tf);
     k = k + 1 + strlen(tf);
     for (i=0 ; i<7; i++) {
          j = strlen(t[i]);
          strcpy(buf+k,t[i]); 
          strcpy(buf+k+j,";");
          k = k+j+1;
     } 
     strcpy(buf+k-1,buf+k);   // pour effacer le dernier ";"
     for (i=0 ; i<7; i++) {
          j = strlen(f[i]);
          strcpy(buf+k,f[i]); 
          k = k+j+1;
          j = strlen(t[i]);
          strcpy(buf+k,t[i]);
          k = k+j+1;
     } 
     return buf;
}

bool openModel() {                // on active le dossier
OPENFILENAME ofn;                 // du fichier image et on
CHAR szFile[MAX_PATH+1]={0};      // retient son nom complet : nomModel
     if(faire == 1) return TRUE;  // sauf si nomModel est dj connu
     ZeroMemory(&ofn, sizeof(OPENFILENAME));
     ofn.lStructSize = sizeof(OPENFILENAME);
     ofn.hwndOwner = hWnd;
     ofn.lpstrFile = szFile;
     ofn.nMaxFile = MAX_PATH;
     ofn.lpstrTitle="Choisissez le fichier du modle  ouvrir.";
     ofn.lpstrFilter = filtre();
     ofn.nFilterIndex = 1;
     ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
     if(GetOpenFileName(&ofn)==TRUE) {
          HANDLE hf;
          hf = CreateFile(szFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
          strcpy(nomModel,szFile);
          CloseHandle(hf);
          faire=1;            // maintenant nomModel est connu
          return TRUE;
     }
     return FALSE;     // l'ouverture du fichier a t annule
}

void rer(int n) {
char buf1[]="Problme n ";
char buf2[]=" dans la lecture du fichier : \n\n";
char bb[3];
     strcpy(buf,buf1);      // on signale un problme 
     sprintf(bb,"%i",n);    // intervenu dans readBMP  readTIFF
     strcat(buf,bb);        // pendant la lecture du fichier
     strcat(buf,buf2);      
     strcat(buf,nomModel);
     informer(buf);
     faire = -1;            // pour traiter l'erreur de lecture
     return;
}

void newModel() {   //  chaque fois que l'on souhaite charger une nouvelle image
char *buffer, *pointeur;  
UCHAR *pix=0;
int i,j;  
     if( openModel() ) {	
          DeleteObject(hBmpMem);
          ReleaseDC(hWnd,hdcMem);
          free(ucpBitsMem);
          ucpBitsMem = NULL;
          strcpy(buf,nomModel);
          buffer = buf;
          while((pointeur=strchr(buffer,'.')) != NULL) strcpy(buffer,pointeur+1);
          if(strncmp(buffer, "bmp", 3) == 0 || strncmp(buffer, "BMP", 3) == 0) readGIF(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "gif", 3) == 0 || strncmp(buffer, "GIF", 3) == 0) readGIF(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "jpg", 3) == 0 || strncmp(buffer, "JPG", 3) == 0) readGIF(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "jpeg",4) == 0 || strncmp(buffer, "JPEG",4) == 0) readGIF(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "png", 3) == 0 || strncmp(buffer, "PNG", 3) == 0) readPNG(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "ppm", 3) == 0 || strncmp(buffer, "PPM", 3) == 0) readPPM(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "tga", 3) == 0 || strncmp(buffer, "TGA", 3) == 0) readTGA(nomModel, &pix, &larg, &haut); 
          if(strncmp(buffer, "tif", 3) == 0 || strncmp(buffer, "TIF", 3) == 0) readTIFF(nomModel,&pix, &larg, &haut); 
          if(strncmp(buffer, "tiff",4) == 0 || strncmp(buffer, "TIFF",4) == 0) readTIFF(nomModel,&pix, &larg, &haut); 
          if(faire == -1) { 
               free(pix);
               pix = NULL;
               newModel();    // a c'est os ! mais ici a marche !
               return;
          }
          ucpBitsMem = (UCHAR*)malloc(4*larg*haut*sizeof(UCHAR));
          if(ucpBitsMem == NULL) { 
               free(pix); pix = NULL;
               rer(1);    newModel();  // allocation impossible de ucpBitsMem[]
               return;
          }
          for(i=0,j=0;i<larg*haut*3;i+=3,j+=4) {
               ucpBitsMem[j+0]=pix[i+2];     
               ucpBitsMem[j+1]=pix[i+1];   // rangement des donnes dans une
               ucpBitsMem[j+2]=pix[i+0];   // bonne structure : W*H*4 ( B G R A )
               ucpBitsMem[j+3]=(UCHAR)0;              
          }
          free(pix);
          pix = NULL;
          hdcMem = CreateCompatibleDC(NULL);     // cration d'un bitmap 
          hBmpMem = BufferToHBitmap(ucpBitsMem,(long)larg,(long)(-haut)); 
          SelectObject(hdcMem,hBmpMem);
          if(prem != 0) { 
               prem = 0;                          // ici on prpare le cas particulier du
               i = mini(lmax(),lsup+larg/zoom);   // premier affichage de la premire image
               j = mini(hmax(),hsup+haut/zoom);
               SetWindowPos(hWnd,0,0,0,i,j,SWP_NOZORDER|SWP_NOMOVE);
          }
          else SetWindowPos(hWnd,0,0,0,lsup+larg/zoom,hsup+haut/zoom,SWP_NOZORDER|SWP_NOMOVE);
          imin = 0;
          guidage();
          model();
          faire=2;   // maintenant la prparation de la nouvelle image est bien termine
	}
      InvalidateRect(hWnd, NULL, TRUE);
      return;
}

void archiver() {  // pour sauvegarder l'image actuelle dans : MonImage.bmp
int i, j, k;
UCHAR *temp;
char message[128];

     // copie de l'image en symtrie haut <--> bas
     temp = (UCHAR *)malloc(4*larg*haut*sizeof(UCHAR));
     for(i=0; i<haut; i++)
         for(j=0; j<larg; j++)
             for(k=0; k<3; k++) {
                  temp[4*(j+(haut-i-1)*larg)+k] = ucpBitsMem[4*(j+i*larg)+k];
             }

    // declare bmp structures 
    BITMAPFILEHEADER bmfh;
    BITMAPINFOHEADER info;
	
	// and initialize them to zero
	memset ( &bmfh, 0, sizeof (BITMAPFILEHEADER) );
	memset ( &info, 0, sizeof (BITMAPINFOHEADER) );
	
	// fill the fileheader with data
	bmfh.bfType = 0x4d42;         // 0x4d42 = 'BM'
	bmfh.bfReserved1 = 0;
	bmfh.bfReserved2 = 0;
	bmfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 4*larg*haut;
	bmfh.bfOffBits = 0x36;		// number of bytes to start of bitmap bits
	
	// fill the infoheader
	info.biSize = sizeof(BITMAPINFOHEADER);
	info.biWidth = larg;
	info.biHeight = haut;
	info.biPlanes = 1;
	info.biBitCount = 32;
	info.biCompression = BI_RGB;	
	info.biSizeImage = 0;
	info.biXPelsPerMeter = 0x0ec4;
	info.biYPelsPerMeter = 0x0ec4;     
	info.biClrUsed = 0;
	info.biClrImportant = 0;
	// now we open the file to write to
	HANDLE file = CreateFile ( "monimage.bmp" , GENERIC_WRITE, FILE_SHARE_READ,
		 NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
	// write file header
	unsigned long bwritten;
	WriteFile ( file, &bmfh, sizeof ( BITMAPFILEHEADER ), &bwritten, NULL );
	// write infoheader
	WriteFile ( file, &info, sizeof ( BITMAPINFOHEADER ), &bwritten, NULL );
	// write image data
	WriteFile ( file, temp, 4*larg*haut, &bwritten, NULL );
	// and close file
	CloseHandle ( file );
      free(temp);
      sprintf(message,"Dans le dossier d'origine de l'image actuelle\n\ncette sauvegarde est archive dans le fichier : monimage.bmp");
      MessageBox(hWnd, message, "message", MB_OK);
}

void HandleFiles(WPARAM wParam) {  // pour capter le nom reu 
TCHAR szName[MAX_PATH+1];          // en glisser-dposer dans la fentre
     HDROP hDrop = (HDROP)wParam;
     int count = DragQueryFile(hDrop, 0xFFFFFFFF,  szName, MAX_PATH);
     for(int i = 0; i < count; i++) DragQueryFile(hDrop, i,  szName, MAX_PATH);
     DragFinish(hDrop);
     strcpy(nomModel,(const char *)szName);
     return;
}

void zoomer() {   // pour zoomer la fentre quand c'est autoris
     if(nmax != 0 ) return;  // quand l'image est maximise le zoom remis  1 est non modifiable
     if(imin != 0 ) return;  // si l'image actuelle est une miniature : chelle 1 non modifiable
     zoom=(33*zoom-7*zoom*zoom-14)/6;
     if(prem == 1) SetWindowPos(hWnd,0,0,0,larg/zoom,haut/zoom,SWP_NOZORDER|SWP_NOMOVE);
     if(prem == 0) SetWindowPos(hWnd,0,0,0,lsup+larg/zoom,hsup+haut/zoom,SWP_NOZORDER|SWP_NOMOVE);
     InvalidateRect(hWnd, NULL, TRUE);
     guidage();
     return;
}

void flouter() {    
int i, j, k, na, nb;                                        // pour un flou avec 0 < a=alfa < b=beta < 0.125
UCHAR *temp;
double alfa, beta, tota;                                    //                   k  l  m
     alfa=0.03;                                             //                   n  p  q
     beta=0.09;                                             //                   r  s  t
     temp = (UCHAR*)malloc(4*larg*haut*sizeof(UCHAR));
     for(i=0; i<larg*haut*4; i++) temp[i] = ucpBitsMem[i];  //  nouveau p = (1-4a-4b)p+a(k+m+r+t)+b(l+n+q+s)  
     for(i=0; i<haut; i++)          // i : indice ligne
         for(j=0; j<larg; j++)      // j : indice colonne
             for(k=0; k<3; k++) {   // pour RGB seulement 
                 na = nb = 0;
                 tota = 0.0;
                 if(j>0      && i>0     ) {tota = tota + alfa*(double)temp[4*((j-1)+(i-1)*larg)+k]; na=na+1;}
                 if(j>0      && i<haut-1) {tota = tota + alfa*(double)temp[4*((j-1)+(i+1)*larg)+k]; na=na+1;}
                 if(j<larg-1 && i>0     ) {tota = tota + alfa*(double)temp[4*((j+1)+(i-1)*larg)+k]; na=na+1;}
                 if(j<larg-1 && i<haut-1) {tota = tota + alfa*(double)temp[4*((j+1)+(i+1)*larg)+k]; na=na+1;}
                 if(j>0     ) {tota = tota + beta*(double)temp[4*((j-1)+i*larg)+k]; nb=nb+1;}
                 if(i>0     ) {tota = tota + beta*(double)temp[4*(j+(i-1)*larg)+k]; nb=nb+1;}
                 if(i<haut-1) {tota = tota + beta*(double)temp[4*(j+(i+1)*larg)+k]; nb=nb+1;}
                 if(j<larg-1) {tota = tota + beta*(double)temp[4*((j+1)+i*larg)+k]; nb=nb+1;}
                 tota = tota + (1.0-(alfa*(double)na+beta*(double)nb))*(double)temp[4*(j+i*larg)+k];
                 ucpBitsMem[4*(j+i*larg)+k] = (UCHAR)((int)(tota+0.5));  // 0.5 pour la conversion double => int
             }
     free (temp);
     hBmpMem = BufferToHBitmap(ucpBitsMem, (long)larg, (long)(-haut));   // mise  jour de l'image affiche
     SelectObject(hdcMem, hBmpMem);
     InvalidateRect(hWnd, NULL, TRUE);     
}
   
double inline dabs(double x){return (x<0)?-x:x;}
   
void debruiter() {   // transformation en ondelettes
double *temp;        // et restitution dbruite
double *vect;
double sigma, seuil, s, t;
int largt, hautt, maxt, i, j, k, itmp, ln, hn, n;
     largt=hautt=2;
     while(largt<larg) largt=2*largt;
     while(hautt<haut) hautt=2*hautt;
     temp = (double*)malloc(4*largt*hautt*sizeof(double));
     for(i=0; i<largt*hautt*4; i=i+4) {
          temp[i+0] = 33.0;
          temp[i+1] = 33.0;
          temp[i+2] = 33.0;
          temp[i+3] = 0.0;
     }
     for(i=0; i<haut; i++)         // copie et conversion de l'image actuelle
         for(j=0; j<larg; j++)
             for(k=0; k<3; k++) {
                  temp[4*(j+i*largt)+k] = (double)ucpBitsMem[4*(j+i*larg)+k];
             }
     maxt=largt;
     if(maxt<hautt) maxt=hautt;
     vect = (double*)malloc(maxt*sizeof(double));
     ln=largt;
     hn=hautt;
     for(n=0; n<nn; n++) {            // transforme en ondelettes  nn niveaux
         for(i=0; i<hn; i++) for(k=0; k<3; k++) {  // transformation des lignes
             for(j=0; j<ln; j++) vect[j]=temp[4*(j+i*largt)+k];
             transformer(vect, ln);                              //                   |---------------|
             for(j=0; j<ln; j++) temp[4*(j+i*largt)+k]=vect[j];  //                   |BB2|HB2|       |
         }                                                       //                   |---|---|  HB1  |
         for(j=0; j<ln; j++) for(k=0; k<3; k++) {  // transformation des colonnes     |BH2|HH2|       |
             for(i=0; i<hn; i++) vect[i]=temp[4*(j+i*largt)+k];  //                   |-------|-------|
             transformer(vect, hn);                              //                   |       |       |
             for(i=0; i<hn; i++) temp[4*(j+i*largt)+k]=vect[i];  //                   |  BH1  |  HH1  |
         }                                                       //                   |       |       |
         ln=ln/2;                                                //                   |---------------|
         hn=hn/2;  
     // HB1 signifie : frquences hautes pour les lignes, basses pour les colonnes et 1-er niveau de transforme, etc.
     }
     sigma=sigmab(temp, largt, hautt);  // estimation de l'cart type du bruit
     ln=largt;
     hn=hautt;
     switch(ms) {
        case 1:                         // seuillage dur n 1 ( avec le NormalShrink )
           for(n=0; n<nn; n++) {
               if(intscr!=0) seuil = (double)intscr;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 1);
               for(i=0; i<hn/2; i++)         // les 3 composantes RGB sont annules ensemble
                   for(j=ln/2; j<ln; j++) {  // seuillage du rectangle HBn
                       s=0.0; for(k=0;k<3;k++){t=temp[4*(j+i*largt)+k]; s=s+t*t;} s=sqrt(s);
                       if(s < seuil) for(k=0; k<3; k++) temp[4*(j+i*largt)+k]=0.0;
                   }
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 2);
               for(i=hn/2; i<hn; i++)        // seuillage du rectangle BHn
                   for(j=0; j<ln/2; j++) {
                       s=0.0; for(k=0;k<3;k++){t=temp[4*(j+i*largt)+k]; s=s+t*t;} s=sqrt(s);
                       if(s < seuil) for(k=0; k<3; k++) temp[4*(j+i*largt)+k]=0.0;
                   }
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 3);
               for(i=hn/2; i<hn; i++)        // seuillage du rectangle HHn
                   for(j=ln/2; j<ln; j++) {
                       s=0.0; for(k=0;k<3;k++){t=temp[4*(j+i*largt)+k]; s=s+t*t;} s=sqrt(s);
                       if(s < seuil) for(k=0; k<3; k++) temp[4*(j+i*largt)+k]=0.0;
                   }
               ln=ln/2;
               hn=hn/2;
           }
           break;
        case 2:                         // seuillage dur n 2 ( avec le NormalShrink )
           for(n=0; n<nn; n++) {
               if(intscr!=0) seuil = (double)intscr;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 1);
               for(i=0; i<hn/2; i++)         // chaque composante RGB est annule sparment
                   for(j=ln/2; j<ln; j++)    // seuillage du rectangle HBn
                       for(k=0; k<3; k++) 
                           if(dabs(temp[4*(j+i*largt)+k])<seuil) temp[4*(j+i*largt)+k]=0.0;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 2);
               for(i=hn/2; i<hn; i++)        // seuillage du rectangle BHn
                   for(j=0; j<ln/2; j++)
                       for(k=0; k<3; k++) 
                           if(dabs(temp[4*(j+i*largt)+k])<seuil) temp[4*(j+i*largt)+k]=0.0;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 3);
               for(i=hn/2; i<hn; i++)        // seuillage du rectangle HHn
                   for(j=ln/2; j<ln; j++)
                       for(k=0; k<3; k++) 
                           if(dabs(temp[4*(j+i*largt)+k])<seuil) temp[4*(j+i*largt)+k]=0.0;
               ln=ln/2;
               hn=hn/2;
           }
           break;
        case 3:                         // seuillage doux ( avec le NormalShrink )
           for(n=0; n<nn; n++) {
               if(intscr!=0) seuil = (double)intscr;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 1);
               for(i=0; i<hn/2; i++)         // chaque composante RGB est annule sparment
                   for(j=ln/2; j<ln; j++)    // seuillage du rectangle HBn
                       for(k=0; k<3; k++) 
                           if(dabs(temp[4*(j+i*largt)+k])<seuil) temp[4*(j+i*largt)+k]=0.0;
                           else if(temp[4*(j+i*largt)+k]>0.0) temp[4*(j+i*largt)+k]=temp[4*(j+i*largt)+k]-seuil;
                                else temp[4*(j+i*largt)+k]=temp[4*(j+i*largt)+k]+seuil;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 2);
               for(i=hn/2; i<hn; i++)        // seuillage du rectangle BHn
                   for(j=0; j<ln/2; j++)
                       for(k=0; k<3; k++) 
                           if(dabs(temp[4*(j+i*largt)+k])<seuil) temp[4*(j+i*largt)+k]=0.0;
                           else if(temp[4*(j+i*largt)+k]>0.0) temp[4*(j+i*largt)+k]=temp[4*(j+i*largt)+k]-seuil;
                                else temp[4*(j+i*largt)+k]=temp[4*(j+i*largt)+k]+seuil;
               if(intscr==0) seuil = sqrt(log((double)(ln*hn/4)/(double)nn))*sigma*sigma/ecart(temp, largt, ln, hn, 3);
               for(i=hn/2; i<hn; i++)        // seuillage du rectangle HHn
                   for(j=ln/2; j<ln; j++)
                       for(k=0; k<3; k++) 
                           if(dabs(temp[4*(j+i*largt)+k])<seuil) temp[4*(j+i*largt)+k]=0.0;
                           else if(temp[4*(j+i*largt)+k]>0.0) temp[4*(j+i*largt)+k]=temp[4*(j+i*largt)+k]-seuil;
                                else temp[4*(j+i*largt)+k]=temp[4*(j+i*largt)+k]+seuil;
               ln=ln/2;
               hn=hn/2;
           }
           break;
     }
     for(n=0; n<nn; n++) {                         // restitution  nn niveaux
         ln=ln*2; 
         hn=hn*2;
         for(j=0; j<ln; j++) for(k=0; k<3; k++) {  // restitution des colonnes
             for(i=0; i<hn; i++) vect[i]=temp[4*(j+i*largt)+k];
             restituer(vect, hn);
             for(i=0; i<hn; i++) temp[4*(j+i*largt)+k]=vect[i];
         }
         for(i=0; i<hn; i++) for(k=0; k<3; k++) {  // restitution des lignes
             for(j=0; j<ln; j++) vect[j]=temp[4*(j+i*largt)+k];
             restituer(vect, ln);
             for(j=0; j<ln; j++) temp[4*(j+i*largt)+k]=vect[j];
         }
     }
     free(vect);
     for(i=0; i<haut; i++)      // mise  jour de l'image affiche
         for(j=0; j<larg; j++)
             for(k=0; k<3; k++) {
                  itmp = (int)(temp[4*(j+i*largt)+k]+0.5);
                  if(itmp<0) itmp=0;
                  if(itmp>255) itmp=255;
                  ucpBitsMem[4*(j+i*larg)+k] = (UCHAR)itmp;
             }
     free(temp);
     hBmpMem = BufferToHBitmap(ucpBitsMem, (long)larg, (long)(-haut)); 
     SelectObject(hdcMem, hBmpMem);
     InvalidateRect(hWnd, NULL, TRUE);     
}

BOOL APIENTRY Dialog1Proc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
  static HWND hsb;
  static SCROLLINFO si;
    switch (uMsg)
    {
      case WM_INITDIALOG:
         {
          hsb = GetDlgItem(hDlg, ID_SB1);
          ZeroMemory(&si, sizeof(SCROLLINFO));
          si.cbSize = sizeof(si);
          si.fMask  = SIF_RANGE | SIF_POS;
          si.nMin   = 0;
          si.nMax   = 1000;
          si.nPos   = intscr;
          SetScrollInfo(hsb, SB_CTL, &si, FALSE);
          SetDlgItemInt(hDlg, ID_LT1, intscr, FALSE);
          return TRUE;
         }

      case WM_HSCROLL:
         GetScrollInfo((HWND)lParam, SB_CTL, &si);
         switch (LOWORD(wParam))
           {
            case SB_PAGEUP:
                si.nPos -= 2;
                if(si.nPos < si.nMin) si.nPos = si.nMin ;
                break;

              case SB_PAGEDOWN:
                si.nPos += 2;
                if(si.nPos > si.nMax) si.nPos = si.nMax ;
                break;

              case SB_LINEUP:
                if(si.nPos > si.nMin) si.nPos--;
                break;

              case SB_LINEDOWN:
                if(si.nPos < si.nMax) si.nPos++;
                break;

              case SB_THUMBPOSITION:
                si.nPos = HIWORD(wParam);
                break;
            }
          si.fMask  = SIF_POS;
          SetScrollInfo((HWND)lParam, SB_CTL, &si, TRUE);
          SetDlgItemInt(hDlg, ID_LT1, si.nPos, FALSE);
          return TRUE;

      case WM_COMMAND:
         if (LOWORD(wParam) == IDOK)
                {
                   GetScrollInfo(hsb, SB_CTL, &si);
                   intscr = si.nPos;
                   EndDialog(hDlg, DB_OK);
                   return TRUE;
                }

         if (LOWORD(wParam) == IDCANCEL)
                {
                   EndDialog(hDlg, 0);
                   return TRUE;
                }

      default:
         return FALSE;
    }
}

LRESULT CALLBACK WndProc(HWND hWind, UINT message, WPARAM wParam, LPARAM lParam) {

LRESULT ret = 0L;
int i,j,k,im,jm;
double di,dj;
char se[3][9]={"dur n 1","dur n 2","doux    "};

     switch (message) {   
   
          case WM_CREATE: 
               HFONT hFont;
               RECT berec;
               hEdit = CreateWindowEx(WS_EX_CLIENTEDGE , "xxx", "zzz", WS_CHILD | WS_VISIBLE | 
                       ES_MULTILINE | ES_WANTRETURN | WS_VSCROLL, 0, 0, 0, 0, hWind, NULL, hinst, NULL);
               hFont = (HFONT)GetStockObject(ANSI_FIXED_FONT);
               SendMessage(hEdit, WM_SETFONT, (UINT)hFont, TRUE);
               SendMessage(hEdit, EM_SETMARGINS, EC_LEFTMARGIN | EC_RIGHTMARGIN, MAKELONG(5,5));
               InitCommonControls();
               hBe = CreateStatusWindow(WS_CHILD | WS_VISIBLE, " Ici votre guidage ...", hWind, (UINT)-1);
               GetWindowRect(hBe, &berec);
               hbet = berec.bottom - berec.top;      // hauteur de la barre d'tat
               xe = GetSystemMetrics(SM_CXSCREEN);   // largeur de l'cran
               ye = GetSystemMetrics(SM_CYSCREEN);   // hauteur de l'cran
               return ret;

          case WM_PAINT: 
               PAINTSTRUCT ps;
               if( nmax > 1 ) {      // les fentres maximises qui suivent sans interruption 
                    zoom = 1;        // la premire maximise doivent afficher des images nouvelles
                    SetWindowPos(hWind,0,0,0,lmax(),hmax(),SWP_NOMOVE|SWP_NOREDRAW);
                    InvalidateRect(hWind, NULL, TRUE);
                    guidage();
               }
               hDC = BeginPaint( hWind , &ps );
               if(hBmpMem != NULL) {
                    if(cy > 120 || larg > 120) {
                         SetStretchBltMode(hDC,HALFTONE);
                         StretchBlt(hDC,0,0,cx,cy,hdcMem,0,0,larg,haut,SRCCOPY);      // cas gnral
                    }
                    else {  // pour afficher l'image actuelle qui est une miniature
                        for(j=0 ; j<cy ; j=j++)
                             for(i=0 ; i<cx ; i=i++) {
                                  k=4*(i+larg*j);
                                  SetPixelV(hDC,i,j,RGB(0xD0,0xD0,0xD0));  // avec un fond gris clair
                             }
                        for(j=0 ; j<haut ; j=j++)  
                             for(i=0 ; i<larg ; i=i++) {
                                  k=4*(i+larg*j);
                                  SetPixelV(hDC,(i+(cx-larg)/2),(j+(cy-haut)/2),
                                            RGB(ucpBitsMem[k+2],ucpBitsMem[k+1],ucpBitsMem[k]));
                             }
                        imin = 1;   //  on annonce le fait d'avoir une image miniature
                        guidage();
                    }
               }
               else {               // pour afficher une image dont la cration de hBmpMem a chou
               di = (double)larg/(double)cx;
               dj = (double)haut/(double)cy;
               for(j=0 ; j<cy ; j=j++)
                    for(i=0 ; i<cx ; i=i++) {
                         im = (int)(di*(double)i);   // de 0  (larg-1)
                         jm = (int)(dj*(double)j);   // de 0  (haut-1)
                         k=4*(im+larg*jm);
                         SetPixelV(hDC,i,j,RGB(ucpBitsMem[k+2],ucpBitsMem[k+1],ucpBitsMem[k]));
                    }
               }
               EndPaint( hWind , &ps );
               return ret;

          case WM_ERASEBKGND: 
               /* au dbut on affiche la fentre noire ( hbrBackground ) */
               if(prem == 1) return DefWindowProc(hWind, message, wParam, lParam);
               /* ensuite on bloque le scintillement pendant le redimensionnement de la fentre */
               return 1;  

          case WM_SIZE: 
               cx = LOWORD(lParam);
               cy = HIWORD(lParam)-hbet;
               if( wParam == SIZE_MAXIMIZED ) {        // la premire fentre maximise n'a pas besoin
                    nmax = nmax+1;         // d'un traitement particulier, les suivantes en ont besoin
               }
               if( wParam != SIZE_MAXIMIZED && nmax != 0 ) { // la fentre revient en mode redimensionnable
                    nmax = 0;                                // c'est  faire la premire fois uniquement
                    SetWindowPos(hWnd,0,0,0,lsup+larg/zoom,hsup+haut/zoom,SWP_NOZORDER|SWP_NOMOVE);
                    InvalidateRect(hWind, NULL, TRUE);
                    guidage();      
               }
               MoveWindow(hEdit, 0, 0, cx, cy, TRUE);
               MoveWindow(hBe, 0, cy, cx, hbet, TRUE);
               return ret;

          case WM_SIZING:  // pour autoriser les variations de taille par l'utilisateur
               RECT *r;    // tout en maintenant constant le ratio : largeur/hauteur de l'image
               double ratio,diff;
               r=LPRECT(lParam);
               ratio = (double)larg/(double)haut;

               switch(wParam) {

                    case WMSZ_LEFT:
                    case WMSZ_RIGHT: 
                    case WMSZ_TOPLEFT:
                    case WMSZ_BOTTOMLEFT:
                    if(prem == 1) {
                       diff = ((double)(r->right - r->left))/ratio;
                       r->bottom = r->top + (LONG)diff;
                    }
                    else {
                         diff = ((double)(r->right - r->left - (LONG)lsup) + 0.5)/ratio;
                         r->bottom = r->top + (LONG)diff + (LONG)hsup;
                    }
                    break;

                    case WMSZ_TOP:
                    case WMSZ_BOTTOM:
                    case WMSZ_TOPRIGHT:
                    case WMSZ_BOTTOMRIGHT:
                    if(prem == 1) {
                         diff = ((double)(r->bottom - r->top))*ratio;
                         r->right = r->left + (LONG)diff;
                    }
                    else {
                         diff = ((double)(r->bottom - r->top - (LONG)hsup) + 0.5)*ratio;
                         r->right = r->left + (LONG)diff + (LONG)lsup;
                    }
               }
               return ret;   
/*
          case WM_SIZING:  // pour interdire les variations de taille par l'utilisateur.
               ((LPRECT)lParam)->right=((LPRECT)lParam)->left+lsup+larg/zoom;
               ((LPRECT)lParam)->bottom=((LPRECT)lParam)->top+hsup+haut/zoom;
               return ret;   
*/
          case WM_GETMINMAXINFO:      // pour limiter la taille de la fentre
               LPMINMAXINFO lpmmi;
               lpmmi = (LPMINMAXINFO)lParam;
               if(prem == 1) {
                    lpmmi->ptMinTrackSize.x = 120;      // largeur minimale 
                    lpmmi->ptMinTrackSize.y = 120;      // de la fentre : 120 pixels
               }
               if(prem == 0) {
                    lpmmi->ptMinTrackSize.x = lsup+120;
                    lpmmi->ptMinTrackSize.y = hsup+(int)(120.0*(double)haut/(double)larg);
                    lpmmi->ptMaxTrackSize.x = lmax();   // largeur et hauteur maximales
                    lpmmi->ptMaxTrackSize.y = hmax();   // de la fentre selon l'cran
               }
               return ret;

          case WM_COMMAND:

               switch( wParam ) {
                   
                    case IDM_FILEOPEN:
                         newModel();
                         break;

                    case IDM_FILESAVE:
                         archiver();
                         break;

                    case IDM_FILEEXIT:
                         SendMessage( hWind, WM_CLOSE, 0, 0);
                         break;
                 
                    case IDM_VUEZOOM:
                         zoomer();
                         break;
              
                    case IDM_VUEFLOU:
                         flouter();
                         break;

                    case IDM_VUESEUIL:
              {
                if(DialogBox(hinst, "DIALOG1" , hWnd, (DLGPROC)Dialog1Proc)== DB_OK)
                                                 InvalidateRect(hWnd,NULL,TRUE);
              }
                         break;
                 
                    case IDM_VUEMESE:
                         ms = (11*ms-3*ms*ms-4)/2;
                         sprintf(buf,"Maintenant on utilisera le seuillage %s",se[ms-1]);
                         MessageBox(hWnd, buf, "Nouvelle mthode de seuillage", MB_OK);
                         break;

                    case IDM_VUEDEBR:
                         debruiter();
                         break;

                   case IDM_HELPHELP:
                        modedemploi();
                        break;

                   case IDM_HELPABOUT:
                        informer("Copyright  PGL10\n\npgl10@yahoo.com");
                        break;
               }
               return ret;
  
          case WM_KEYDOWN:

               switch (wParam) {

                    case VK_F1:
                         modedemploi();
                         break;

                    case 'N':
                         newModel();
                         break;

                    case 'O':
                         if(GetAsyncKeyState(VK_CONTROL)) newModel();
                         break;

                    case 'Q':
                         PostQuitMessage(0);
                         break;

                    case 'Z':
                         zoomer();
                         break;

                    case 'F':
                         flouter();
                         break;

                    case 'S':
        {
            if(DialogBox(hinst, "DIALOG1" , hWnd, (DLGPROC)Dialog1Proc)== DB_OK)
                                                 InvalidateRect(hWnd,NULL,TRUE);
        }
                         break;

                    case 'D':
                         debruiter();
                         break;

                    case 'M':
                         ms = (11*ms-3*ms*ms-4)/2;
                         sprintf(buf,"Maintenant on utilisera le seuillage %s",se[ms-1]);
                         MessageBox(hWnd, buf, "Nouvelle mthode de seuillage", MB_OK);
                         break;

                    case VK_DOWN:
                         nextImage();
                         faire = 1;
                         newModel();
                         break;

                    case VK_UP:
                         previousImage();
                         faire = 1;
                         newModel();
                         break;

                    case VK_ESCAPE:
                         PostQuitMessage(0);
                         break;
               }
               return ret;

          case WM_CLOSE:
               DestroyWindow(hWind);
               return ret;

          case WM_MENUSELECT: 
               if(lParam == (LONG)GetMenu(hWind)) {
                    if(LOWORD(wParam) == 0) guider(" Menu fichier");
                    if(LOWORD(wParam) == 1) guider(" Menu vue");
                    if(LOWORD(wParam) == 2) guider(" Menu aide");
               }
               else {
                    if(LOWORD(wParam) == IDM_FILEOPEN)  guider(" Ouvrir une nouvelle image");
                    if(LOWORD(wParam) == IDM_FILESAVE)  guider(" Archiver l'image actuelle");
                    if(LOWORD(wParam) == IDM_FILEEXIT)  guider(" Pour quitter l'application.");
                    if(LOWORD(wParam) == IDM_VUEZOOM)  guider(" Zoom : chelle 1 ou 1/2 ou 1/4");
                    if(LOWORD(wParam) == IDM_VUEFLOU)  guider(" Pour afficher avec du flou");
                    if(LOWORD(wParam) == IDM_VUESEUIL)  guider(" Pour choisir manuellement le seuil");
                    if(LOWORD(wParam) == IDM_VUEMESE)  guider(" Pour changer la mthode de seuillage");
                    if(LOWORD(wParam) == IDM_VUEDEBR)  guider(" Pour dbruiter l'image affiche");
                    if(LOWORD(wParam) == IDM_HELPHELP)  guider(" Afficher le mode d'emploi.");
                    if(LOWORD(wParam) == IDM_HELPABOUT) guider(" Afficher le copyright.");
               }
               return ret;

          case WM_EXITMENULOOP:
               if(faire == 0) guider(" Ici votre guidage ...");
               else guidage();
               return ret;

          case WM_DROPFILES:           // pour un glisser-dposer dans la fentre
               HandleFiles(wParam);
               InvalidateRect(hWind, NULL, TRUE);
               faire=1;
               newModel();
               return ret;

          case WM_DESTROY:
               PostQuitMessage(0);
               return ret;

          default:
               ret = DefWindowProc(hWind, message, wParam, lParam);
     }
     return ret;
}

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int iCmdShow) {

WNDCLASSEX wincl;        // Datastructure de la windowclass 
HMENU menu;              // handle pour le menu 
MSG msg;
char szClassName[] = "MaWinClass";
char *buffer;

     hinst = hThisInstance;
     strcpy(nomModel,"[]");
     larg=512;
     haut=512;
     zoom=1;
     prem=1;
     nmax=0;
     ucpBitsMem = (UCHAR*)malloc(4*larg*haut); 
     for(int i=0; i<4*larg*haut; i++) ucpBitsMem[i]=(char)0; 

     /* The Window structure */
     wincl.hInstance = hThisInstance;
     wincl.lpszClassName = szClassName;
     wincl.lpfnWndProc = WndProc;                           
     wincl.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;                 
     wincl.cbSize = sizeof(WNDCLASSEX);
     wincl.hIcon = LoadIcon(hThisInstance, MAKEINTRESOURCE(ID_ICON));
     wincl.hIconSm = LoadIcon(hThisInstance, MAKEINTRESOURCE(ID_ICON));
     wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
     wincl.lpszMenuName = NULL;                 
     wincl.cbClsExtra = 0;                     
     wincl.cbWndExtra = 0;                      
     wincl.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);   /* couleur du fond */

     if(!RegisterClassEx(&wincl)) return 0; /* Register the window class, if fail quit the program */

     /* The class is registered, lets create the program*/
     DWORD dwStyleEx = WS_EX_ACCEPTFILES;
     hWnd = CreateWindowEx(
          dwStyleEx,           /* Extended possibilites */
          szClassName,         /* Classname */
          monprojet,           /* Title Text */
          WS_OVERLAPPEDWINDOW, /* defaultwindow */
          CW_USEDEFAULT,       /* Windows decides the position */
          CW_USEDEFAULT,       /* where the window end up on the screen */
          larg,                /* The programs width */
          haut,                /* and height in pixels */
          HWND_DESKTOP,        /* The window is a childwindow to desktop */
          NULL,                /* No menu here */
          hThisInstance,       /* Program Instance handler */
          NULL);               /* No Window Creation data */
  
     /* Make the window visible on the screen */
     ShowWindow(hWnd, iCmdShow);
     menu = LoadMenu(hThisInstance, MAKEINTRESOURCE(ID_MENU));
     SetMenu(hWnd, menu);

     /* Action initiale */               // Pour afficher par un glisser-dposer du fichier sur l'excutable. 
     if(lpCmdLine[0] != '\0') {          // Et si on associe MesImages et un type ou des types de fichier 
          buffer = lpCmdLine;            // on pourra afficher l'image par un double clic sur le fichier. 
          strcpy(nomModel,buffer);       
          if(nomModel[0] == '"') {            // pour effacer les
               strcpy(nomModel,buffer+1);     // deux caractres : "
               buffer=strchr(nomModel,'"');   // ajouts par Windows
               *buffer='\0';
         }
         faire = 1;          // on a reu le nomModel d'un fichier  afficher
     }
     else faire=0;           // mais si on n'a rien reu ...

     newModel();

     /* Program main loop */
     while (GetMessage(&msg, NULL, 0, 0)) {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
     }
     return (int)msg.wParam;
}
