#include "utils.h"

// Fonction personnelle : quivalent de ZeroMemory (merci  BruNews pour celle-ci)
__declspec(naked) void __fastcall myZeroMemory (void *destination, UINT size)
{ // ecx = destination, edx = size
	__asm
	{
		test  edx, edx
		mov   eax, edx
		je    short zeroEXIT
		and   eax, 7
		sub   edx, eax
		jz    short finHUIT
parHUIT:
		mov   dword ptr[ecx], 0
		mov   dword ptr[ecx+4], 0
		add   ecx, 8
		sub   edx, 8
		jnz   short parHUIT
finHUIT:
		test  eax, eax
        	je    short zeroEXIT
parUN:
		mov   byte ptr[ecx], 0
		inc   ecx
		dec   eax
		jnz   short parUN
zeroEXIT:
		ret 0
  }
}

HBITMAP BufferToHBitmap(unsigned char *buffer, long lx, long ly ) {
// de : http://forum.hardware.fr/hfr/Programmation/C-2/modifier-pixels-vc-sujet_50119_1.htm
HDC             hDC, hDCBmp;
HBITMAP         hBmp, hBmpOld;
BITMAPINFO      BitmapInfo;   

    if (buffer==NULL) return NULL;
  
    //Initialisation des donnes DI Bits 
//  memset( &BitmapInfo, 0, sizeof(BITMAPINFO) );      ( remplac ci-dessous )
    myZeroMemory( &BitmapInfo, sizeof(BITMAPINFO) );
    BitmapInfo.bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
    BitmapInfo.bmiHeader.biWidth         = lx;
    BitmapInfo.bmiHeader.biHeight        = ly;   // positif ou ngatif : inversion haut <--> bas
    BitmapInfo.bmiHeader.biPlanes        = 1;
    BitmapInfo.bmiHeader.biBitCount      = 32;
    BitmapInfo.bmiHeader.biCompression   = BI_RGB;
    BitmapInfo.bmiHeader.biSizeImage     = 0;
    BitmapInfo.bmiHeader.biXPelsPerMeter = 0;
    BitmapInfo.bmiHeader.biYPelsPerMeter = 0;
    BitmapInfo.bmiHeader.biClrUsed       = 0;
    BitmapInfo.bmiHeader.biClrImportant  = 0;
    BitmapInfo.bmiColors[0].rgbRed       = 0xFF;
    BitmapInfo.bmiColors[0].rgbGreen     = 0xFF;
    BitmapInfo.bmiColors[0].rgbBlue      = 0xFF;
    BitmapInfo.bmiColors[0].rgbReserved  = 0;
                                             
    hDC = GetDC ( NULL );
    hDCBmp = CreateCompatibleDC ( hDC );
    hBmp = CreateCompatibleBitmap ( hDC, lx, labs(ly) );
    hBmpOld = (HBITMAP)SelectObject ( hDCBmp, hBmp );
    ReleaseDC ( NULL, hDC );

    SetDIBits ( hDCBmp, hBmp, 0, labs(ly), buffer, &BitmapInfo, DIB_RGB_COLORS );

    //Libration des ressources 
    SelectObject ( hDCBmp, hBmpOld );
    DeleteDC ( hDCBmp );

    return hBmp;
}

bool isGood(char *t) {  // le type *t est-il un type de fichier image reconnu ?
     if(strlen(t) == 3 ) {
          if(strncmp(t, "bmp", 3) == 0 || strncmp(t, "BMP", 3) == 0) return TRUE;
          if(strncmp(t, "gif", 3) == 0 || strncmp(t, "GIF", 3) == 0) return TRUE;
          if(strncmp(t, "jpg", 3) == 0 || strncmp(t, "JPG", 3) == 0) return TRUE;
          if(strncmp(t, "png", 3) == 0 || strncmp(t, "PNG", 3) == 0) return TRUE;
          if(strncmp(t, "ppm", 3) == 0 || strncmp(t, "PPM", 3) == 0) return TRUE;
          if(strncmp(t, "tga", 3) == 0 || strncmp(t, "TGA", 3) == 0) return TRUE;
          if(strncmp(t, "tif", 3) == 0 || strncmp(t, "TIF", 3) == 0) return TRUE;
     }
     if(strlen(t) == 4 ) {
          if(strncmp(t, "jpeg", 4) == 0 || strncmp(t, "JPEG", 4) == 0) return TRUE;
          if(strncmp(t, "tiff", 4) == 0 || strncmp(t, "TIFF", 4) == 0) return TRUE;
     }
     return FALSE;
}

void transformer(double *v, int n) {
    int m;
    m=2;
    while(pow(2.0,m)<n) m=m+1;
    daub8(v, m);  // on choisit ici le modle d'ondelette  utiliser
}

void restituer(double *v, int n) {
    int m;
    m=2;
    while(pow(2.0,m)<n) m=m+1;
    daub8_inv(v, m); // transforme inverse de l'ondelette utilise
}

double inline dabs(double x){return (x<0)?-x:x;}

double mediane(double *v, int n) {  // la mdiane des |v[i]|
     double va, vb, vc, vx;
     int i, ia, ib, ic, id, im;
     im=n/2;    // on veut im valeurs v[i] plus petites que le rsultat
     vx=dabs(v[0]);
     for(i=0; i<n; i++) if(dabs(v[i])>vx) vx=dabs(v[i]);
     ia = 0;
     va = 0.0;
     ib = n;
     vb = vx;
     id=2*n;
     for(;;) {
         vc = (va+vb)/2.0;
         ic = 0;
         for(i=0; i<n; i++) if(dabs(v[i])<vc) ic=ic+1;
         if(ic>im) {vb=vc; ib=ic;}
         else {va=vc; ia=ic;}
         if((ib-ia)<=id) break;
         id=ib-ia;
     }
     return vc;
}

double sigmab(double *temp, int largt, int hautt) {  // estimation de l'cart type du bruit
    double *tmod;
    int l2, h2, i, j, k;
    double *tmp;
    double s1, s2, s3, sm, t2, tk;
    tmod = (double*)malloc(largt*hautt*sizeof(double));
    for(i=0; i<hautt; i++)
        for(j=0; j<largt; j++) {
            t2=0.0;
            for(k=0; k<3; k++) {
                tk=temp[4*(j+i*largt)+k];
                t2=t2+tk*tk;
            }
            tmod[j+i*largt]=sqrt(t2);    // on range ici les mesures RGB successives
        }
    l2=largt/2;  
    h2=hautt/2;
    tmp = (double*)malloc(l2*h2*sizeof(double));
    /*  1-er rectangle des basses frquences verticales et des hautes frquences horizontales  */
    k=0;
    for(i=0; i<h2; i++)       
        for(j=l2; j<largt; j++) tmp[k++]=tmod[j+largt*i];  // rectangle BH1
    s1 = mediane(tmp, l2*h2);
    /*  1-er rectangle des hautes frquences verticales et des basses frquences horizontales  */
    k=0;
    for(i=h2; i<hautt; i++)
        for(j=0; j<l2; j++) tmp[k++]=tmod[j+largt*i];     // rectangle HB1
    s2 = mediane(tmp, l2*h2);
    /*  1-er rectangle des hautes frquences verticales et des hautes frquences horizontales  */
    k=0;
    for(i=h2; i<hautt; i++)
        for(j=l2; j<largt; j++) tmp[k++]=tmod[j+largt*i];  // rectangle HH1
    s3 = mediane(tmp, l2*h2);
    free(tmod);
    free(tmp);
    sm = (s1+s2+s3)/3.0;
    sm = sm/0.6745;       // c'est une variante  essayer !
    sm = s3/0.6745;       // c'est la vraie formule !
    return sqrt(sm);
}

double ecart(double *temp, int largt, int ln, int hn, int r) {
double m[3], s[3], t;  // calcul de l'cart type d'un rectangle,
int i, j, k, ii, ji;   // HBn si r=1 ou BHn si r=2 ou HHn si r=3
    if(r==1) ii = 0; else ii = hn/2;
    if(r==2) ji = 0; else ji = ln/2;
    for(k=0; k<3; k++) m[k] = 0.0;
    for(i=ii; i<ii+hn/2; i++)       // les 3 moyennes pour R, G, et B
        for(j=ji; j<ji+ln/2; j++)
            for(k=0; k<3; k++) m[k] = m[k]+temp[4*(j+i*largt)+k];
    for(k=0; k<3; k++) m[k] = m[k]/((double)(ln*hn/4));
    for(k=0; k<3; k++) s[k] = 0.0;
    for(i=ii; i<ii+hn/2; i++)       // les 3 carts types pour R, G, et B
        for(j=ji; j<ji+ln/2; j++)
            for(k=0; k<3; k++) {
                t = temp[4*(j+i*largt)+k]-m[k];
                s[k] = s[k]+t*t;
            }
    for(k=0; k<3; k++) s[k] = sqrt(s[k]/((double)(ln*hn/4)));
    return (s[0]+s[1]+s[2])/3.0;    // cart type RGB moyen 
}
